<?php
class DDA_Cache{
	function get($name){
		$option = 'ddacache_' . $name;
		if( DDA_Cache::expired($name) )
			return false;
		return get_option($option);
	}
	function set($name, $value, $expire=86400){
		$option = 'ddacache_' . $name;
		$expire = time() + $expire;
		
		if( ! DDA_Cache::expired($name) && $value == get_option($option) )
			return true; //Do not set them again if the previous object has not expired and is the same.
		
		$expires = get_option('ddacache_expires') ? get_option('ddacache_expires') : array();
		$expires[$name] = $expire;
		update_option('ddacache_expires', $expires);
		
		delete_option($option);
		add_option($option, $value, null, 'no');
	}
	function expired($name){
		$expire = (array)get_option('ddacache_expires');

		if( ! isset($expire[$name]) ) //Do we have it cached?
			return true;

		if( $expire[$name] > time() ) //Is it still safe?
			return false;

		//Ok, Delete it, Its stale
		delete_option('ddacache_' . $name);
		
		unset($expire[$key]);
		update_option('ddacache_expires', $expire);
		
		return true; //Its "expired"
	}
	function cleanup(){
		$expires = get_option('ddacache_expires') ? get_option('ddacache_expires') : array();
		foreach($expires as $option => $time)
			delete_option($option);
		delete_option('ddacache_expires');
	}
}
?>