<?php
	if( ! defined('ABSPATH') ) die();
	$widgets = get_option('dda_widgets') ? get_option('dda_widgets') : array();
	$selected_widget = isset($_POST['widget_select']) ? $_POST['widget_select'] : '';
	if( isset($_POST['add-widget']) ){
		$widgets['new-widget'] = array('name' => 'New Widget', 'slug' => 'new-widget');
		$selected_widget = 'new-widget';
	}
	if( isset($_POST['save-widget']) ){
		check_admin_referer('dda_widget-update');
		echo '<div class="updated"><p>Your Widget settings have been saved</p></div>';
		
		$widget = array();
		$widget['name'] = $_POST['widget']['name'];
		$widget['slug'] = !empty($_POST['widget']['slug']) ? $_POST['widget']['slug'] : sanitize_title_with_dashes($widget['name']);
		if( 'rss' == $_POST['widget']['type'] ){
			$widget['user'] = false;
			$widget['fav'] = false;
			$widget['search'] = false;
			$widget['type'] = 'rss';
			$widget['feed'] = $_POST['widget']['feed'];
		} else {
			//Query
			$widget['type'] = 'query';
			$widget['user'] = ('by' == $_POST['widget']['query-type']);
			$widget['fav'] = ('favby' == $_POST['widget']['query-type']);
			$widget['search'] = ('search' == $_POST['widget']['query-type']);
			
			$widget['term'] = $_POST['widget']['query-term'];
			
			$widget['order'] = $_POST['widget']['order'];
			$widget['scraps'] = !isset($_POST['widget']['scraps']) ? false : ( 'on' == $_POST['widget']['scraps']);
			$widget['mature'] = !isset($_POST['widget']['mature']) ? false : ( 'on' == $_POST['widget']['mature']);
		}
		$widget['random'] = !isset($_POST['widget']['random']) ? false : ( 'on' == $_POST['widget']['random']);
		$widget['number'] = (int)$_POST['widget']['number'];
		$widget['library'] = !isset($_POST['widget']['library']) ? false : ( 'on' == $_POST['widget']['library']);
		if( $widget['library'] )
			$widget['size'] = $_POST['widget']['size'];
		
		if( isset($_POST['widget']['customhtml']) && 'on' == $_POST['widget']['customhtml'] )
			if( ! empty($_POST['widget']['html']) )
				$widget['html'] = $_POST['widget']['html'];
		
		$widgets[ $widget['slug'] ] = $widget;
		update_option('dda_widgets', $widgets);
		$selected_widget = $widget['slug'];
	}
	
	if( empty($selected_widget) ){
		$lw = array_keys($widgets);
		$selected_widget = $widgets[ $lw[0] ]['slug'];
	}
?>
<script type="text/javascript">
	jQuery(document).ready(function(){
			jQuery('.js-hidden').hide();
			jQuery('#widget-type-query').change( function(){ 
				jQuery('#rss-section').hide();
				jQuery('#query-section').show();
			});
			jQuery('#widget-type-rss').change( function(){ 
				jQuery('#query-section').hide();
				jQuery('#rss-section').show();
			});
			jQuery('#widget-library').change(function(){ 
				if( jQuery('#widget-library').is(":checked") )
					jQuery('#image-size').show();
				else
					jQuery('#image-size').hide();
			});
			jQuery('#widget-customhtml').change(function(){ 
				if( jQuery('#widget-customhtml').is(":checked") )
					jQuery('#custom-html').show();
				else
					jQuery('#custom-html').hide();
			});
		});
</script>
<div class="wrap">
<h2>dDeviantArt Settings</h2>
<form action="options-general.php?page=<?php echo $_REQUEST['page']; ?>" method="post">
<?php wp_nonce_field('dda_widget-update'); ?>
	<h3>Widget Settings</h3>
	<div class="nav">
		<?php if( ! empty($widgets) ){ ?>
		Select Widget
		<select name="widget_select">
			<?php foreach($widgets as $widget){
					echo '<option value="' . $widget['slug'] . '"';
					echo selected($widget['slug'], $selected_widget);
					echo '>' . $widget['name'] . "</option>\r\n";
				}
			?>
		</select>
		<input type="submit" name="load_widget" value="Load" class="button-secondary" />
		Or 
		<?php } ?>
		<input type="submit" name="add-widget" value="Add New" class="button-secondary" />
	</div>
	<div class="widget">
		<?php
			$widget =& $widgets[$selected_widget];
		?>
		<input type="hidden" name="slug" value="<?php echo $widget['slug'] != 'new-widget' ? $widget['slug'] : '' ?>" />
		<fieldset title="Widget Settings">
			<label for="widget-name">Widget Name:</label> <input type="text" name="widget[name]" id="widget-name" value="<?php echo $widget['name'] ?>" width="30" /><br />
			<input type="radio" name="widget[type]" id="widget-type-query" value="query" <?php checked($widget['type'], 'query'); ?>/> <label for="widget-type-query">Manual Query</label>
			<input type="radio" name="widget[type]" id="widget-type-rss" value="rss" <?php checked($widget['type'], 'rss'); ?>/> <label for="widget-type-rss">RSS Feed</label><br />
			<fieldset id="rss-section" <?php echo ($widget['type'] == 'rss') ? '' : 'class="js-hidden"' ?>>
				<label for="widget-rss-feed">RSS Feed:</label> <input type="text" name="widget[feed]" id="widget-rss-feed" value="<?php echo $widget['feed'] ?>" width="50" style="width:80%" />
			</fieldset>
			<fieldset id="query-section" <?php echo ($widget['type'] == 'query') ? '' : 'class="js-hidden"' ?>>
				Deviation is..<br />
				<input type="radio" name="widget[query-type]" id="widget-query-by" value="by" <?php checked($widget['user'], true); ?>/> <label for="widget-query-by">By User</label>
				<input type="radio" name="widget[query-type]" id="widget-query-favby" value="favby" <?php checked($widget['fav'], true); ?>/> <label for="widget-query-favby">Favourited By User</label>
				<input type="radio" name="widget[query-type]" id="widget-query-search" value="search" <?php checked($widget['search'], true); ?>/> <label for="widget-query-search">In search results for</label><br />
				<input type="text" name="widget[query-term]" value="<?php echo $widget['term'] ?>" /><br />
				Order Deviations by..<br />
				<div style="float:left; margin-right:50px">
				<input type="radio" name="widget[order]" id="widget-order-time" value="time"<?php checked($widget['order'], 'time') ?> />
					<label for="widget-order-time">Time</label><br />
				<input type="radio" name="widget[order]" id="widget-order-popular24h" value="popular24h"<?php checked($widget['order'], 'popular24h') ?> />
					<label for="widget-order-popular24h">Popular (1 Day)</label><br />
				<input type="radio" name="widget[order]" id="widget-order-popular3d" value="popular3d"<?php checked($widget['order'], 'popular3d') ?> />
					<label for="widget-order-popular3d">Popular (3 Days)</label><br />
				</div>
				<div style="float:left">
				<input type="radio" name="widget[order]" id="widget-order-popular1w" value="popular1w"<?php checked($widget['order'], 'popular1w') ?> />
					<label for="widget-order-popular1w">Popular (Last Week)</label><br />
				<input type="radio" name="widget[order]" id="widget-order-popular1m" value="popular1m"<?php checked($widget['order'], 'popular1m') ?> />
					<label for="widget-order-popular1m">Popular (Last Month)</label><br />
				<input type="radio" name="widget[order]" id="widget-order-popular" value="popular"<?php checked($widget['order'], 'popular') ?> />
					<label for="widget-order-popular">Popular (All Time)</label><br />	
				</div>
				<br class="clear" />
				<input type="checkbox" name="widget[scraps]" id="widget-scraps" <?php checked($widget['scraps'], true) ?> /> <label for="widget-scraps">Include Scraps</label>
				<input type="checkbox" name="widget[mature]" id="widget-mature" <?php checked($widget['mature'], true) ?> /> <label for="widget-mature">Include Mature Content</label>
			</fieldset>
			<br />
			<fieldset>
				<input type="checkbox" name="widget[random]" id="widget-random" <?php checked($widget['random'], true) ?> /> <label for="widget-random">Randomise Order</label>
				<input type="checkbox" name="widget[library]" id="widget-library" <?php checked($widget['library'], true) ?> /> <label for="widget-library">Store images in Media Library</label>
				<input type="checkbox" name="widget[customhtml]" id="widget-customhtml" <?php checked(!empty($widget['html']), true) ?> /> <label for="widget-customhtml">Customise the image HTML</label><br />
				<label for="widget-numbet">Number of Deviations to display</label>
					<select name="widget[number]" id="widget-number">
						<?php
							for ($i=1; $i <= 24; $i++){
								$selected = ($i == $widget['number']) ? ' selected="selected"' : '';
								echo "<option$selected>$i</option>\r\n";
							}
						?>
					</select>
				<div id="image-size" <?php echo ($widget['library'] == true) ? '' : 'class="js-hidden"' ?>>
				Maximum image size <label for="widget-sizeh">H: </label> <input type="text" name="widget[size][h]" id="widget-sizeh" value="<?php echo $widget['size']['h'] ?>" style="width:2em" />
									<label for="widget-sizew">W: </label> <input type="text" name="widget[size][w]" id="widget-sizew" value="<?php echo $widget['size']['w'] ?>" style="width:2em" />
									<em>(Note: Only is effective when storing in the Media library, And if using the <strong>%image</strong> token tag if using the customised HTML option)</em>
				</div>
				<div id="custom-html" <?php echo (!empty($widget['html'])) ? '' : 'class="js-hidden"' ?>>
					<textarea name="widget[html]" style="width:100%" rows="3"><?php echo !empty($widget['html']) ? stripslashes($widget['html']) : dda_default_widget_html(); ?></textarea><br />
					Available Tags:<br />
					<div style="float:left; margin-right:50px">
						<strong>%link%</strong> = Link to the Deviation <br />
						<strong>%title%</strong> = The Deviation Title<br />
						<strong>%category%</strong> = The Category of the Deviation<br />
						<strong>%symbol%, %author%</strong> = The Authors Deviantart Symbol, &amp; Username<br />
						<strong>%time%</strong> = The Submission time<br />
					</div>
					<div style="float:left">
						<strong>%id%</strong> = The Deviation Id<br />
						<strong>%image%</strong> = The Local thumbnail of widget size<br />
						<strong>%image150%</strong> = The URL of the 150px Thumbnail on the DeviantArt servers.<br />
						<strong>%image300%</strong> = The URL of the 300px Thumbnail on the DeviantArt servers.<br />
						<strong>%imagefull%</strong> = The URL of the fullsize on the DeviantArt servers.
					</div>
					<br style="clear" />
				</div>
					
			</fieldset>
		</fieldset>
	</div>
	<p class="submit">
		<input type="submit" name="save-widget" value="Save Changes" class="button" />
	</p>
</form>
</div>

<div class="wrap">
	<form action="options-general.php?page=<?php echo $_REQUEST['page']; ?>" method="post">
	<h3>General Settings</h3>
	<?php wp_nonce_field('dda_general-update'); ?>
	
	<p class="submit">
		<input type="submit" name="clear-cache" value="Clear Cache" class="button" />
		<input type="submit" name="update-general" value="Save Changes" class="button" />
	</p>
</form>
</div>

<?php
	//var_dump($_POST);
	//var_dump( array('DeviationList', DeviantArt::getDeviations(array('user'=>'dd32')) ));
	//var_dump( array('Deviation', DeviantArt::getDeviation(81210993) ));
?>